(def if
   (macro (l)
	  (cond ((eq (length l) 3) `(cond (,(cadr l) ,(caddr l))))
		((eq (length l) 4) `(cond (,(cadr l) ,(caddr l))
					  (t ,(cadddr l)))))))

(def genbase
   (lambda ()
      (cons '&base nil)))

(def extendbase
   (lambda (i v)
      (let ((base-env (scheme-fluid 'base-environment)))
	   (rplacd base-env
	      (cons (cons i v)
		    (cdr base-env))))))
    
(def removefrombase
   (lambda (i)
      (let ((pr (or (assq i 
		       (cdr (setq tempbase (scheme-fluid 'base-environment))))
		    (assq i 
		       (cdr (setq tempbase (scheme-fluid 'system-base)))))))
	   (cond
	      ((null pr) nil)
	      (t (rplacd tempbase (delete pr (cdr tempbase))))))))

(def base-identifiers
   (lambda ()
      (append
	 (mapcar 'car (cdr (scheme-fluid 'system-base)))
	 (mapcar 'car (cdr (scheme-fluid 'base-environment))))))

(def lookupinbase
   (lambda (i)
      (let ((pr (or (assq i (cdr (scheme-fluid 'base-environment)))
		    (assq i (cdr (scheme-fluid 'system-base))))))
	   (cond
	      ((null pr) (raise (list 'SE%base 0 t
				   '|Unbound base identifier:| i)))
	      (t (cdr pr))))))

(def baselocation
   (lambda (i)
      (or (assq i (cdr (scheme-fluid 'base-environment)))
	  (assq i (cdr (scheme-fluid 'system-base))))))
	      
(def scheme-reset
   (lambda ()
      (set-scheme-fluid 'scheme-top-level
	      (global-binding 'scheme-top-level))
      (reset)))

